function CCoin (oPlayer, iX, iY) {
    var _oCoin;
    var _iX = iX;
    var _iY = iY;
    var _oParentContainer = s_oGame.getContainer();
    var bColliding;
    var bUpdate;
    var _oBounceTween;
    var _iTimeElapsCoin;

    this._init = function() {
        _iTimeElapsCoin = 0;
        bColliding = false;
        bUpdate = true;
        
        var oData = {   
                images: [s_oSpriteLibrary.getSprite("coin")], 
                framerate: 30,
                // width, height & registration point of each sprite
                frames: {width: COIN_WIDTH, height: COIN_HEIGHT, regX: 0, regY: 0}, 
                animations: {idle:[0, 19, "idle"]}
            };
        var oSpriteSheet = new createjs.SpriteSheet(oData);

        _oCoin = createSprite(oSpriteSheet, "idle", 0, 0, COIN_WIDTH, COIN_HEIGHT);
        _oCoin.regX = COIN_WIDTH/2;
        _oCoin.regY = COIN_HEIGHT/2;
        _oCoin.x = _iX;
        _oCoin.y = _iY;
        _oParentContainer.addChild(_oCoin);
        
        createjs.Tween.get(_oCoin, {loop: false}).to({y: _iY - 150}, 500, createjs.Ease.cubicOut).call(this._BounceBack);
        playSound("money_bounce",0.4,0);
    };

    this.returnColliding = function() {
        return bColliding;
    };

    this._BounceBack = function() {
        _oBounceTween = createjs.Tween.get(_oCoin, {loop: false}).to({y: _iY}, 1000, createjs.Ease.bounceOut);
    }

    this.coinDisappearTween = function() {
        createjs.Tween.get(_oCoin).to({alpha: 0}, 250);
    };

    this.playerCollision = function() {
        if (_oBounceTween !== undefined) {
            createjs.Tween.removeTweens(_oCoin);
        };
        
        var iDestinationX = s_oInterface.getScoreIconX();
        var iDestinationY = s_oInterface.getScoreIconY();

        createjs.Tween.get(_oCoin).to({x: iDestinationX, y: iDestinationY, alpha: 0.2}, 1000, createjs.Ease.backIn).call(function () { _oParentContainer.removeChild(_oCoin); }).call(s_oInterface.scoreIconPulse);
        bColliding = true;
    };

    this.getX = function() {
        return _oCoin.x;
    };

    this.getY = function() {
        return _oCoin.y;
    };

    this.isUpdate = function() {
        return bUpdate;
    }

    this.update = function() {
        _iTimeElapsCoin += s_iTimeElaps;

        // After some time, the coin must disappear
        if (_iTimeElapsCoin > COIN_DISAPPEARING_INTERVAL) {
            bUpdate = false;
            _iTimeElapsCoin = 0;
            s_oGame.disappearCoin(this);
        };
    };

    this._init(_oParentContainer);
};