function CCyclops (oParentContainer) {
    var _oCyclops;
    var _oParentContainer = oParentContainer;
    var _oShake;

    var _iAnimationPause = 500; // How many ms the frame will freeze at the end of each punch

    this._init = function(oParentContainer) {
        var data = {    
            images: [s_oSpriteLibrary.getSprite("cyclops_0001"),
                     s_oSpriteLibrary.getSprite("cyclops_0002"),
                     s_oSpriteLibrary.getSprite("cyclops_0003"),
                     s_oSpriteLibrary.getSprite("cyclops_0004"),
                     s_oSpriteLibrary.getSprite("cyclops_0005"),
                     s_oSpriteLibrary.getSprite("cyclops_0006"),
                     s_oSpriteLibrary.getSprite("cyclops_0007"),
                     s_oSpriteLibrary.getSprite("cyclops_0008"),
                     s_oSpriteLibrary.getSprite("cyclops_0009"),
                     s_oSpriteLibrary.getSprite("cyclops_0010"),
                     s_oSpriteLibrary.getSprite("cyclops_0011"),
                     s_oSpriteLibrary.getSprite("cyclops_0012"),
                     s_oSpriteLibrary.getSprite("cyclops_0013"),
                     s_oSpriteLibrary.getSprite("cyclops_0014"),
                     s_oSpriteLibrary.getSprite("cyclops_0015"),
                     s_oSpriteLibrary.getSprite("cyclops_0016"),
                     s_oSpriteLibrary.getSprite("cyclops_0017"),
                     s_oSpriteLibrary.getSprite("cyclops_0018"),
                     s_oSpriteLibrary.getSprite("cyclops_0019"),
                     s_oSpriteLibrary.getSprite("cyclops_0020"),
                     s_oSpriteLibrary.getSprite("cyclops_0021"),
                     s_oSpriteLibrary.getSprite("cyclops_0022"),
                     s_oSpriteLibrary.getSprite("cyclops_0023"),
                     s_oSpriteLibrary.getSprite("cyclops_0024"),
                     s_oSpriteLibrary.getSprite("cyclops_0025"),
                     s_oSpriteLibrary.getSprite("cyclops_0026"),
                     s_oSpriteLibrary.getSprite("cyclops_0027"),
                     s_oSpriteLibrary.getSprite("cyclops_0028"),
                     s_oSpriteLibrary.getSprite("cyclops_0029"),
                     s_oSpriteLibrary.getSprite("cyclops_0030"),
                     s_oSpriteLibrary.getSprite("cyclops_0031"),
                     s_oSpriteLibrary.getSprite("cyclops_0032"),
                     s_oSpriteLibrary.getSprite("cyclops_0033"),
                     s_oSpriteLibrary.getSprite("cyclops_0034")],
            frames: {width: 716, height: 719},
            animations: { idle:         [0, 17], 
                          punch_right:  [18, 23], 
                          punch_left:   [24, 29], 
                          back_to_idle: [30, 33, "idle"]
                        },
            framerate: 15
        };
        var oSpriteSheet = new createjs.SpriteSheet(data);

        _oCyclops = createSprite(oSpriteSheet, "idle", 0, 0, 716, 719);
        _oCyclops.regX = 716/2;
        _oCyclops.regY = 719/2;
        _oCyclops.x = CANVAS_WIDTH / 2 + 60;
        _oCyclops.y = CANVAS_HEIGHT / 2 - 50;
        _oParentContainer.addChild(_oCyclops);
        _oCyclops.on('animationend', this._changeAnimation);
    };
    
    this._changeAnimation = function() {
        var min = Math.ceil(0);
        var max = Math.floor(4);
        var iRandom = Math.floor(Math.random() * (max - min)) + min;
    
        if (s_oGame.isPaused() === true) {
            return;
        };
        if (s_oGame.isPaused() === false) {
            // after an animation, another animation is randomly selected
                if (_oCyclops.currentAnimation === 'idle') {
                    if (iRandom === 0) {
                    _oCyclops.gotoAndPlay('punch_right'); };
                    if (iRandom === 1) {
                    _oCyclops.gotoAndPlay('punch_left'); };
                    if (iRandom >= 2) {
                    _oCyclops.gotoAndPlay('idle'); };
            } else if (_oCyclops.currentAnimation === 'punch_right') {
                _oCyclops.gotoAndStop(23);
                playSound("punch",1,0);
                s_oGame.playDebrisRight();
                s_oCyclops._callShake();
                setTimeout(function(){ 
                    if (iRandom === 0) {
                        _oCyclops.gotoAndPlay('punch_right'); };
                        if (iRandom === 1) {
                        _oCyclops.gotoAndPlay('punch_left'); };
                        if (iRandom === 2) {
                        _oCyclops.gotoAndPlay('idle'); };
                        if (iRandom === 3) {
                        _oCyclops.gotoAndPlay('back_to_idle'); };
                }, _iAnimationPause);
            } else if (_oCyclops.currentAnimation === 'punch_left') {
                _oCyclops.gotoAndStop(29);
                playSound("punch",1,0);
                s_oGame.playDebrisLeft();
                s_oCyclops._callShake();
                setTimeout(function(){ 
                    if (iRandom === 0) {
                    _oCyclops.gotoAndPlay('punch_right'); };
                    if (iRandom === 1) {
                    _oCyclops.gotoAndPlay('punch_left'); };
                    if (iRandom >= 2) {
                    _oCyclops.gotoAndPlay('back_to_idle'); };
                }, _iAnimationPause);
            };
        };
    };

    this.pauseAnimation = function() {
        _oCyclops.stop();
    };
    
    this.resumeAnimation = function() {
        _oCyclops.play();
    };
    
    this._callShake = function() {
        _oShake = new CShake(_oParentContainer, 500, 5, 20);
    };
    
    s_oCyclops = this;

    this._init(oParentContainer);
};

var s_oCyclops;