function CEndPanel(oSpriteBg, iScore){
    var _oFade;
    var _oBg;
    var _oGroup;
    
    var _oMsgTextStroke;
    var _oMsgText;
    var _oScoreTextStroke;
    var _oScoreText;
    var _oButRestart;
    var _oButHome;
    var _iScore = iScore;
    
    var _oGameOverSound;
    
    var _oParent = this;
    
    this._init = function(oSpriteBg){
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        _oFade.alpha = 0.5;
        s_oStage.addChild(_oFade);
        
        _oBg = createBitmap(oSpriteBg);
        _oBg.regX = oSpriteBg.width * 0.5;
        _oBg.regY = oSpriteBg.height * 0.5;
        _oBg.x = CANVAS_WIDTH/2;
        _oBg.y = CANVAS_HEIGHT/2;
        
        _oMsgTextStroke = new createjs.Text(""," 60px "+PRIMARY_FONT, "#410701");
        _oMsgTextStroke.x = CANVAS_WIDTH/2+1;
        _oMsgTextStroke.y = (CANVAS_HEIGHT/2)+1 - 20;
        _oMsgTextStroke.textAlign = "center";
        _oMsgTextStroke.textBaseline = "alphabetic";
        _oMsgTextStroke.outline = 3;
        _oMsgTextStroke.lineWidth = 350; 
        
        _oMsgText = new createjs.Text(""," 60px "+PRIMARY_FONT, "#ffb400");
        _oMsgText.x = CANVAS_WIDTH/2;
        _oMsgText.y = (CANVAS_HEIGHT/2) - 20;
        _oMsgText.textAlign = "center";
        _oMsgText.textBaseline = "alphabetic";
        _oMsgText.lineWidth = 350;      
        
        _oScoreTextStroke = new createjs.Text(""," 40px "+PRIMARY_FONT, "#410701");
        _oScoreTextStroke.x = CANVAS_WIDTH/2+1;
        _oScoreTextStroke.y = (CANVAS_HEIGHT/2) + 91;
        _oScoreTextStroke.textAlign = "center";
        _oScoreTextStroke.textBaseline = "alphabetic";
        _oScoreTextStroke.lineWidth = 350;
        _oScoreTextStroke.outline = 3;
        
        _oScoreText = new createjs.Text(""," 40px "+PRIMARY_FONT, "#ffb400");
        _oScoreText.x = CANVAS_WIDTH/2;
        _oScoreText.y = (CANVAS_HEIGHT/2) + 90;
        _oScoreText.textAlign = "center";
        _oScoreText.textBaseline = "alphabetic";
        _oScoreText.lineWidth = 350;
        
        _oButRestart = createBitmap(s_oSpriteLibrary.getSprite('but_restart'));
        _oButRestart.x = CANVAS_WIDTH/2+15;
        _oButRestart.y = CANVAS_HEIGHT/2+130;
        
        _oButHome = createBitmap(s_oSpriteLibrary.getSprite('but_home'));
        _oButHome.x = CANVAS_WIDTH/2-105;
        _oButHome.y = CANVAS_HEIGHT/2+130;
        
        _oGroup = new createjs.Container();
        _oGroup.alpha = 0;
        _oGroup.visible=false;
        
        _oGroup.addChild(_oBg, _oScoreTextStroke, _oScoreText, _oMsgTextStroke, _oMsgText, _oButRestart, _oButHome);

        s_oStage.addChild(_oGroup);
        s_oGame.pause();
    };
    
    this.unload = function(){
        _oButHome.off("mousedown",this._onExit);
        _oButRestart.off("mousedown",this._onRestart);
    };
    
    this._initListener = function(){
        _oButHome.on("mousedown",this._onExit);
        _oButRestart.on("mousedown",this._onRestart);
    };
    
    this.show = function(iScore){
        setVolume("soundtrack", 0)
	_oGameOverSound = playSound("game_over",1,0);
        _oMsgTextStroke.text = TEXT_GAMEOVER;
        _oMsgText.text = TEXT_GAMEOVER;
        
        _oScoreTextStroke.text = TEXT_SCORE + ": " + iScore;
        _oScoreText.text = TEXT_SCORE + ": " + iScore;
        
        _oGroup.visible = true;
        
        createjs.Tween.get(_oGroup).to({alpha:1 }, 500).call(function() {_oParent._initListener();});
        
        $(s_oMain).trigger("share_event",[iScore]);
        $(s_oMain).trigger("save_score",[iScore]);
    };
    
    this._onExit = function(){
        _oParent.unload();
        playSound("press_button",1,0);
        s_oStage.removeChild(_oGroup);
        
        s_oGame.onExit();
        stopSound(_oGameOverSound);
        $(s_oMain).trigger("share_event", _iScore);
    };
    
    this._onRestart = function(){
        _oParent.unload();
        playSound("press_button",1,0);
        s_oStage.removeChild(_oGroup);
        
        s_oGame.onRestart();
        stopSound(_oGameOverSound);
        setVolume("soundtrack", 1)
        $(s_oMain).trigger("share_event", _iScore);
    };
    
    this._init(oSpriteBg);
    
    return this;
}
