function CGame(oData) {
    var _iScore;
    var _iTimeElapsStone;
    var _iTimeElapsPowerUp0;
    var _iTimeElapsPowerUp1;
    var _iTimeElapsShield;
    var _oInterface;
    var _oEndPanel;
    var _bTouchActive;
    var _oHelpPanel;  
    var _oPlayer;
    var _oGameContainer;
    var _oCyclops;
    var _aFallingObjects;
    var _aCoins;
    var _oCloud1;
    var _oCloud2;
    var _oMountain;
    var _oFloor;
    var _oDebrisL;
    var _oDebrisR;
    var _iPlayerLife;
    var _iCreatedStones;
    var _iStonesCreationInterval;

    var _iForceDirection = 0;
    var _iPlayerAcceleration = 0;
    var _bUpdate = false;
    var _bIsGameOver = false;

    this._init = function(){
        _oEndPanel = null;
        _iScore = 0;
        _iTimeElapsStone = 0;
        _iTimeElapsPowerUp0 = 0;
        _iTimeElapsPowerUp1 = 0;
        _iTimeElapsShield = 0;
        _iCreatedStones = 0;
        _aFallingObjects = [];
        _aCoins = [];
        setVolume(s_oSoundTrack, 0.2);
        _bTouchActive = false;
        _iPlayerLife=PLAYER_LIFE;
        _iStonesCreationInterval = STONES_CREATION_INTERVAL;

        s_oTweenController = new CTweenController();
        
        _oGameContainer = new createjs.Container();
        s_oStage.addChild(_oGameContainer);

        var oBg = createBitmap(s_oSpriteLibrary.getSprite("bg_game"));
        oBg.regX = 800/2;
        oBg.regY = 1450/2;
        oBg.x = CANVAS_WIDTH / 2;
        oBg.y = CANVAS_HEIGHT / 2;
        _oGameContainer.addChild(oBg);

        this._initCloud1();
        
        _oMountain = createBitmap(s_oSpriteLibrary.getSprite("mountain"));
        _oMountain.regX = 437/2;
        _oMountain.regY = 953/2;
        _oMountain.x = CANVAS_WIDTH / 2;
        _oMountain.y = CANVAS_HEIGHT / 2 + 100;
        _oGameContainer.addChild(_oMountain);

        this._initCyclops(_oGameContainer);
        this._initDebris();
        
        _oFloor = createBitmap(s_oSpriteLibrary.getSprite("floor"));
        _oFloor.regX = 800/2;
        _oFloor.regY = 651/2;
        _oFloor.x = CANVAS_WIDTH / 2;
        _oFloor.y = CANVAS_HEIGHT / 2 + 400;
        _oGameContainer.addChild(_oFloor);

        this._initCloud2();
        this._initPlayer(_oGameContainer);

        _oInterface = new CInterface();
        _oHelpPanel = CHelpPanel();
    };

    this._initCloud1 = function() {
        _oCloud1 = createBitmap(s_oSpriteLibrary.getSprite("cloud"));
        _oCloud1.scaleX = _oCloud1.scaleY = 0.4;
        _oCloud1.regX = 311/2;
        _oCloud1.regY = 125/2;
        _oCloud1.x = -200;
        _oCloud1.y = CANVAS_HEIGHT / 2 - 350;
        s_oStage.addChild(_oCloud1);
        _oGameContainer.addChild(_oCloud1);
        createjs.Tween.get(_oCloud1, {loop: false}).to({x: CANVAS_HEIGHT + 150}, 50000, createjs.Ease.Linear).call(handleComplete);

        function handleComplete() {
            s_oStage.removeChild(_oCloud1);
            _oGameContainer.removeChild(_oCloud1);
            s_oGame._initCloud1();
        };
    };

    this._initCloud2 = function() {
        _oCloud2 = createBitmap(s_oSpriteLibrary.getSprite("cloud"));
        _oCloud2.scaleX = _oCloud2.scaleY = 0.8;
        _oCloud2.regX = 311/2;
        _oCloud2.regY = 125/2;
        _oCloud2.x = -200;
        _oCloud2.y = CANVAS_HEIGHT / 2 - 250;
        s_oStage.addChild(_oCloud2);
        _oGameContainer.addChild(_oCloud2);
        createjs.Tween.get(_oCloud2, {loop: false}).to({x: CANVAS_HEIGHT + 150}, 15000, createjs.Ease.Linear).call(handleComplete);       
        
        function handleComplete() {
            s_oStage.removeChild(_oCloud2);
            _oGameContainer.removeChild(_oCloud2);
            s_oGame._initCloud2();
        };
    };

    this._initPlayer = function(){
        _oPlayer = new CPlayer(_oGameContainer) ;  
    };

    this._initDebris = function(){
        var iDebrisY = 420;
        
        _oDebrisL = new CDebris(CANVAS_WIDTH / 2 -200, iDebrisY, _oGameContainer, -1) ;
        _oDebrisR = new CDebris(CANVAS_WIDTH / 2 +200, iDebrisY, _oGameContainer, 1) ;  
    };

    this.playDebrisLeft = function() {
        _oDebrisL.restartAnimation();
    };

    this.playDebrisRight = function() {
        _oDebrisR.restartAnimation();
    };

    this._initCyclops = function(){
        _oCyclops = new CCyclops(_oGameContainer) ;  
    };

    //START GAME
    this.setUpdateTrue = function(){
        if(_bUpdate || _bIsGameOver){
            return;
        }
        
        _bUpdate = true;
    };

    this.getContainer = function() {
        return _oGameContainer;
    };
    
    this.unload = function(){
        _bUpdate = false;
        _oInterface.unload();
        createjs.Tween.removeAllTweens();
        s_oStage.removeAllChildren();
        s_oGame = null;
    };

    this.onExit = function(){
        setVolume(s_oSoundTrack, 1);
        
        s_oGame.unload();
        s_oMain.gotoMenu();

        $(s_oMain).trigger("end_session");
        $(s_oMain).trigger("show_interlevel_ad");
    };

    this._onExitHelp = function(){
        if(!s_bMobile) {
            document.onkeydown = onKeyDown; 
            document.onkeyup   = onKeyUp; 
        };
        
        if(s_bMobile) {
            this._initMouseMove();
        };
        _bUpdate = true;
    };

    //DETECTIONG MOUSE MOVE
    this._initMouseMove = function() {
        if(!s_bCanOrientate){
            s_oStage.on("stagemouseup", function() {
                _iForceDirection = 0;
                _iPlayerAcceleration = 0;
            });
            s_oStage.on("stagemousemove", function(evt) {
                _iForceDirection = (evt.stageX-(CANVAS_HALF_WIDTH)) / (CANVAS_HALF_WIDTH-CANVAS_WIDTH_RANGE_ACCEPTED);
                // moving right
                if(Math.abs(_iForceDirection) > 1 ){
                    _iForceDirection = 1;
                }
                // moving left
                if(evt.stageX < CANVAS_HALF_WIDTH){
                    _iForceDirection = -1*Math.abs(_iForceDirection);
                }
                _iPlayerAcceleration = PLAYER_ACCELERATION_NO_GIROSCOPE;
            });
        } else {
            window.addEventListener('deviceorientation', function(eventData) {
                if(eventData.gamma < GAMMA_RANGE_ACCEPTED && eventData.gamma > -GAMMA_RANGE_ACCEPTED){
                    _iForceDirection = eventData.gamma / GAMMA_RANGE_ACCEPTED;
                }else{
                    // moving right
                    if(eventData.gamma < 0){
                        _iForceDirection = -1;
                    // moving left
                    }else{
                        _iForceDirection = 1;
                    }
                    _iPlayerAcceleration = PLAYER_ACCELERATION_GIROSCOPE;
                }
            }, false);
        }
    };

    function onKeyUp(evt){ 
        if (!_bUpdate) {
            return;
        }
        
        evt.preventDefault();
        switch(evt.keyCode) {
            case 37: {  // left  
                    _iForceDirection = 0;
                    _iPlayerAcceleration = 0;
                    break; }
            case 39: {  // right  
                    _iForceDirection = 0;
                    _iPlayerAcceleration = 0;
                    break; }
        };

    };

    function onKeyDown(evt){
        if (!_bUpdate) {
            return;
        }

        if(!evt){ 
            evt = window.event; 
        } 
            evt.preventDefault();
        switch(evt.keyCode) {    
            case 37: {      // left
                _iForceDirection = -1;
                _iPlayerAcceleration = PLAYER_ACCELERATION_NO_GIROSCOPE;
                //_bUpdate = true;
                break;
            };
            case 39: {      // right
                _iForceDirection = 1;
                _iPlayerAcceleration = PLAYER_ACCELERATION_NO_GIROSCOPE;
                //_bUpdate = true;
                break;
            };
        }
    };

    this.gameOver = function(){
		let pathArray = window.location.pathname.split('/');
            let newpath = '';
            if (pathArray[1] && pathArray[1] != 'arcade' && pathArray[1] != 'games') {
				newpath = '/' + pathArray[1];
            }
            scorepost(window.location.protocol + '//' + window.location.hostname + newpath + '/index.php?act=Arcade&do=newscore', {
              gname : 'CyclopsRuins_Origon',
              gscore: _iScore
            });
        if(_iScore > s_iBestScore){
            s_iBestScore = _iScore;
            saveItem("cyclopsruins_best_score" ,_iScore);
        };
        
        if(_oEndPanel === null){
            playSound("game_over",1,0);
            
            _oEndPanel = CEndPanel(s_oSpriteLibrary.getSprite('msg_box'), _iScore);
            _oEndPanel.show(_iScore);
            
            $(s_oMain).trigger("save_score", _iScore);
            $(s_oMain).trigger("show_interlevel_ad");
        }
    }; 

    this._initStone = function(){
        var oStone = new CStone(_oGameContainer, _oPlayer);
        _aFallingObjects.push(oStone);

        // Every X stones created, the stones creation will increase speed
        if (_iStonesCreationInterval > 600) {
            _iCreatedStones++;
        
            if (_iCreatedStones > STONES_CREATION_VAR) {
                _iCreatedStones = 0;
                _iStonesCreationInterval -= STONES_INTERVAL_VAR;
            };
        };
    };
    
    this._initPowerUp = function(_iType) {
        var oPowerUp = new CPowerUp (_iType, _oGameContainer);
        _aFallingObjects.push(oPowerUp);
    };

    this.getScore = function(){
        return _iScore; };

    this.addScore = function() {
        _iScore++;
        s_oInterface.refreshScore(_iScore);
    };

    this.subtractLife = function() {                
        _iPlayerLife -= DAMAGE;
        this.updateHealthBar();
    };

    this.addLife = function() {                
        _iPlayerLife ++; //= HEALTH_POINTS;
        this.updateHealthBar();
    };
    
    this.updateHealthBar = function() {
        if (_iPlayerLife > PLAYER_LIFE){
            _iPlayerLife = PLAYER_LIFE;
        } else if (_iPlayerLife <= 0) {
            playSound("death",1,0);
            _oPlayer.gameOver();
            setInterval(s_oGame.gameOver, 1000);
        };
        var iRate = (_iPlayerLife/PLAYER_LIFE)+0.001;
        
        _oInterface.refreshBar(iRate);
    };
    
    this.checkCoinsCollisions = function(oCoin) {
        var a = oCoin.getX() - _oPlayer.getX();
        var b = oCoin.getY() - _oPlayer.getY();
        var _iDistance = Math.sqrt( a*a + b*b );
        var _iDistanceLimit = 50;
        
        if (_iDistance <= _iDistanceLimit) {
            oCoin.playerCollision();
            _oPlayer.playerTakeCoin();
        };
    };
    
    this.checkCollisions = function(object){
        var a = object.getX() - _oPlayer.getX();
        var b = object.getY() - _oPlayer.getY();
        var _iDistance = Math.sqrt( a*a + b*b );
        var _iDistanceLimit = 80;
        
        if (_iDistance <= _iDistanceLimit) {
            if (object.isStone()) {
                object.stopTween();
                _oPlayer.playerIsHit();
                s_oGame.removeObjectsFromArray(object);
            } else if (object.isStone() === false) {
                if ( object.isShield() === true) {
                    _oPlayer.playerTakeShield();
                };
                if ( object.isShield() === false) {
                    _oPlayer.playerTakeHealth();
                };
                object.destroyPowerUp();
                s_oGame.removeObjectsFromArray(object);
            };
        };
    };

    this.removeCoinFromArray = function(oObject) {
        var iPosition = _aCoins.indexOf(oObject);
        
        _aCoins.splice(iPosition, 1);
        s_oStage.removeChild(oObject);
    };
    
    this.removeObjectsFromArray = function(oObject) {
        var iPosition = _aFallingObjects.indexOf(oObject);
        
        _aFallingObjects.splice(iPosition, 1);
    };
    
    this.stoneBroken = function(iX, iY){
        // Create a coin when the stone hits the floor
        var oCoin = new CCoin( _oPlayer, iX, iY );
        _aCoins.push(oCoin);
    };
    
    this.pause = function() {
        _bUpdate = false;
        _oPlayer.pauseAnimation();
        _oCyclops.pauseAnimation();
    };
    
    this.unpause = function() {
        _bUpdate = true;
        _oPlayer.resumeAnimation();
        _oCyclops.resumeAnimation();
    };
    
    this.onRestart = function(){
        this.unload();
        
        $(s_oMain).trigger("end_level", 1);
        $(s_oMain).trigger("show_interlevel_ad");
        $(s_oMain).trigger("end_session");
        
        s_oMain.gotoGame();
    };
    
    this.isPaused = function() {
        if (!_bUpdate) {
            return true;
        } else {
            return false;
        }
    };
    
    this.disappearCoin = function(oCoin) {
        oCoin.coinDisappearTween();
        s_oGame.removeCoinFromArray(oCoin);
    };
    
    this.update = function() {
        if (!_bUpdate) {
            return;
        }
        
        // update the coins' array
        if (_aCoins.length > 0) {
            for (var i = 0; i < _aCoins.length; i++) {
                if (_aCoins[i].isUpdate() === true ) {
                    _aCoins[i].update();
                };
            };
        };
        
        // update the falling objects' array
        if (_aFallingObjects.length > 0) {
            for (var i = 0; i < _aFallingObjects.length; i++) {
                _aFallingObjects[i].update();
            };
        };
        
        // When the player takes a shield, make it disappear after some time
        if (_oPlayer.isShield() === true) {
            _iTimeElapsShield += s_iTimeElaps;
            
            if(_iTimeElapsShield > SHIELD_DURATION) {
                _iTimeElapsShield = 0;
                _oPlayer.removeShield();
            };
        };

        // Create a new stone at each interval of time
        _iTimeElapsStone += s_iTimeElaps;

        if(_iTimeElapsStone > _iStonesCreationInterval){
            _iTimeElapsStone = 0;
            this._initStone();
        };

        if (_oPlayer.isShield() === false) {
            // Create a new powerup shield at each interval of time
            _iTimeElapsPowerUp0 += s_iTimeElaps;

            if(_iTimeElapsPowerUp0 > SHIELD_CREATION_INTERVAL){
                _iTimeElapsPowerUp0 = 0;
                this._initPowerUp(POWER_UP_SHIELD); };
        };

        if (_iPlayerLife < PLAYER_LIFE) {
            // Create a new powerup health at each interval of time
            _iTimeElapsPowerUp1 += s_iTimeElaps;

            if(_iTimeElapsPowerUp1 > HEALTH_CREATION_INTERVAL){
                _iTimeElapsPowerUp1 = 0;
                this._initPowerUp(POWER_UP_HEALTH); };
        };

        // Move the player (with keyboards, touchscreen, mouse, etc)
        _oPlayer._movePlayer(_iForceDirection, _iPlayerAcceleration);

        // check collisions with the coins' array
        if (_aCoins.length > 0) {
            for (var i = 0; i < _aCoins.length; i++) {
                if ( _aCoins[i].returnColliding() === false ) {
                    s_oGame.checkCoinsCollisions(_aCoins[i]);
                };
            };

            for (var i = 0; i < _aCoins.length; i++) {
            };
        };

        // Collisions check with stones and bonuses            
        for (var i = 0; i < _aFallingObjects.length; i++) {
        var objectY = _aFallingObjects[i].getY();
        
            if ( _aFallingObjects[i].isStone() === true) {
                if ( _aFallingObjects[i].returnColliding() === false) {
                    s_oGame.checkCollisions( _aFallingObjects[i] ); };
                if (objectY > CANVAS_HEIGHT + 100) { 
                    s_oGame.removeObjectsFromArray(_aFallingObjects[i]);
                    _aFallingObjects[i].destroyStone(); };
            } else if (_aFallingObjects[i].isStone() === false) {
                if ( _aFallingObjects[i].returnColliding() === false) {
                    s_oGame.checkCollisions( _aFallingObjects[i] ); };
                if (objectY > CANVAS_HEIGHT + 100) { 
                    s_oGame.removeObjectsFromArray(_aFallingObjects[i]);
                    _aFallingObjects[i].destroyPowerUp(); };
            } else { 
                return; 
            };
        };
    };

    s_oGame = this;

    PLAYER_SPD_MAX                   = oData.player_spd_max;
    PLAYER_SPD_MIN                   = oData.player_spd_min;
    PLAYER_ACCELERATION_NO_GIROSCOPE = oData.player_acceleration_no_giroscope;
    PLAYER_ACCELERATION_GIROSCOPE    = oData.player_acceleration_giroscope;
    PLAYER_DECELERATION              = oData.player_deceleration;
    GAMMA_RANGE_ACCEPTED             = oData.gamma_range_accepted;
    CANVAS_WIDTH_RANGE_ACCEPTED      = oData.canvas_half_width_range_accepted;
    STONES_CREATION_INTERVAL         = oData.stones_creation_interval;
    SHIELD_CREATION_INTERVAL         = oData.shield_creation_interval;
    HEALTH_CREATION_INTERVAL         = oData.health_creation_interval;
    SHIELD_DURATION                  = oData.shield_duration;
    COIN_DISAPPEARING_INTERVAL       = oData.coin_disappearing_interval;
    COIN_POINTS                      = oData.coin_points;
    HEALTH_POINTS                    = oData.health_points;
    PLAYER_LIFE                      = oData.player_life;
    DAMAGE                           = oData.damage;

    this._init();
}

var s_oGame;
var s_oTweenController;