function CHelpPanel(){
    var _oMsgTextOutline;
    var _oMsgText;
    var _oHelpBg;
    var _oGroup;
    var _oFade;
    var _oHelpSprite;
    var _oHelpSpriteCursor;

    this._init = function(){
        _oGroup = new createjs.Container();
        s_oStage.addChild(_oGroup);

        var _oShadow = new createjs.Shape();
        _oShadow.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        _oShadow.alpha = 0.7;
        _oGroup.addChild(_oShadow);

        var oSprite = s_oSpriteLibrary.getSprite('msg_box');
        _oHelpBg = createBitmap(oSprite);
        _oHelpBg.regX = oSprite.width * 0.5;
        _oHelpBg.regY = oSprite.height * 0.5;
        _oHelpBg.x = CANVAS_WIDTH/2;
        _oHelpBg.y = CANVAS_HEIGHT/2;
        _oGroup.addChild(_oHelpBg);

        var pTextPos = {x: CANVAS_WIDTH/2, y: CANVAS_HEIGHT/2};        
        
        _oMsgTextOutline = new createjs.Text(""," 24px "+PRIMARY_FONT, "#000000");
        _oMsgTextOutline.x = CANVAS_WIDTH/2;
        _oMsgTextOutline.y = (CANVAS_HEIGHT/2)+90;
        _oMsgTextOutline.textAlign = "center";
        _oMsgTextOutline.textBaseline = "alphabetic";
        _oMsgTextOutline.lineHeight = 30;
        _oMsgTextOutline.lineWidth = 320;
        _oMsgTextOutline.outline = 3;
        _oGroup.addChild(_oMsgTextOutline);
                
        _oMsgText = new createjs.Text(""," 24px "+PRIMARY_FONT, PRIMARY_FONT_COLOR);
        _oMsgText.x = CANVAS_WIDTH/2;
        _oMsgText.y = (CANVAS_HEIGHT/2)+90;
        _oMsgText.textAlign = "center";
        _oMsgText.textBaseline = "alphabetic";
        _oMsgText.lineHeight = 30;
        _oMsgText.lineWidth = 320;
        _oGroup.addChild(_oMsgText);

        if(!s_bMobile){
            //I'M ON A DESKTOP
            _oMsgTextOutline.text = TEXT_DESKTOP;
            _oMsgText.text = TEXT_DESKTOP;
            _oHelpSprite = createBitmap(s_oSpriteLibrary.getSprite('keyboard'));
            _oHelpSprite.regX = _oHelpSprite.width / 2;
            _oHelpSprite.regY = _oHelpSprite.height / 2;
            _oHelpSprite.x = CANVAS_WIDTH/2 - 105;
            _oHelpSprite.y = CANVAS_HEIGHT/2 - 110;
            _oGroup.addChild(_oHelpSprite);
        }else if(s_bCanOrientate){
            //I'M ON A DEVICE WITH GIROSCOPE
            _oMsgTextOutline.text = TEXT_ORIENTATION;
            _oMsgText.text = TEXT_ORIENTATION;
            
            var oSprite = s_oSpriteLibrary.getSprite('smartphone_rotation');
            var oData = {   
                images: [oSprite], 
                framerate: 15,
                // width, height & registration point of each sprite
                frames: {width: 166, height: 166, regX: 0, regY: 0}, 
                animations: {idle:[0, 19, "idle"]}
            };
            var oSpriteSheet = new createjs.SpriteSheet(oData);

            _oHelpSprite = createSprite(oSpriteSheet, "idle", 0, 0, 166, 166);
            _oHelpSprite.x = CANVAS_WIDTH/2-80;
            _oHelpSprite.y = CANVAS_HEIGHT/2-130;
            _oGroup.addChild(_oHelpSprite);
        }else{
            //I'M ON A DEVICE WITHOUT GIROSCOPE
            _oMsgTextOutline.text = TEXT_MOBILE;
            _oMsgText.text = TEXT_MOBILE;
            _oHelpSprite = createBitmap(s_oSpriteLibrary.getSprite('help_smartphone'));
            _oHelpSprite.x = CANVAS_WIDTH/2-40;
            _oHelpSprite.y = CANVAS_HEIGHT/2-120;
            _oGroup.addChild(_oHelpSprite);
            
            _oHelpSpriteCursor = createBitmap(s_oSpriteLibrary.getSprite('help_touch'));
            _oHelpSpriteCursor.x = CANVAS_WIDTH/2-30;
            _oHelpSpriteCursor.y = CANVAS_HEIGHT/2-60;
            this.moveCursorRight(_oHelpSpriteCursor);
            _oGroup.addChild(_oHelpSpriteCursor);
        }
        
        s_oStage.addChild(_oGroup);
        
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        s_oStage.addChild(_oFade);
        createjs.Tween.get(_oFade).to({alpha:0}, 500).call(function(){_oFade.visible = false;}); 

        var oParent = this;
        _oGroup.on("pressup",function(){oParent._onExitHelp()});
        
        this.show();
    };

    this.moveCursorRightDesktop = function(oSprite){
        var oParent = this;
        createjs.Tween.get(oSprite).to({x: CANVAS_WIDTH/2+70 }, 1000).call(function() {
            oParent.moveCursorLeftDesktop(oSprite);
        });
    }
    
    this.moveCursorLeftDesktop = function(oSprite){
        var oParent = this;
        createjs.Tween.get(oSprite).to({x: CANVAS_WIDTH/2-80 }, 1000).call(function() {
            oParent.moveCursorRightDesktop(oSprite);
        });
    }
    
    this.moveCursorRight = function(oSprite){
        var oParent = this;
        createjs.Tween.get(oSprite).to({x: CANVAS_WIDTH/2 }, 1000).call(function() {
            oParent.moveCursorLeft(oSprite);
        });
    }
    
    this.moveCursorLeft = function(oSprite){
        var oParent = this;
        createjs.Tween.get(oSprite).to({x: CANVAS_WIDTH/2-55 }, 1000).call(function() {
            oParent.moveCursorRight(oSprite);
        });
    }

    this.unload = function(){
        s_oStage.removeChild(_oGroup);
        var oParent = this;
        _oGroup.off("pressup",function(){oParent._onExitHelp()});
    };

    this._onExitHelp = function(){
        this.unload();
        s_oGame._onExitHelp();
    };

    this.show = function(){    
        createjs.Tween.get(_oGroup).to({alpha:1 }, 500);
    };

    this._init();
}