function CInterface() {
    var _oAudioToggle;

    var _pStartPosAudio;
    var _pStartPosExit;
    var _pStartPosFullscreen;
    var _pStartPosHealth;
    var _pStartPosScore;
    var _pStartPosBestScore;
    
    var _oButFullscreen;
    var _fRequestFullScreen = null;
    var _fCancelFullScreen = null;
    var _oButExit;
    var _oButRight;
    var _oButLeft;
    var _oScoreIcon;
    var _oScoreTextBack;
    var _oScoreText;
    var _oBestScoreIcon;
    var _oBestScoreTextBack;
    var _oBestScoreText;
    var _oScoreContainer;
    var _oBestScoreContainer;
    var _oHealthContainer;
    var oShieldIcon;
    var _oMask;
    var _oAreYouSurePanel;
    var _fScaleX;
    var _fScaleY;

    this._init = function () {
        var oSpriteExit = s_oSpriteLibrary.getSprite('but_exit');
        
        _pStartPosExit = {x: CANVAS_WIDTH - oSpriteExit.width/2 - 20, y: (oSpriteExit.height / 2) + 10};
        _oButExit = new CGfxButton(_pStartPosExit.x, _pStartPosExit.y, oSpriteExit,s_oStage);
        _oButExit.addEventListener(ON_MOUSE_UP, this._onExit, this);

        _pStartPosHealth = {x: CANVAS_WIDTH / 2 - 110, y: _pStartPosExit.y - 40};
        _oHealthContainer = new createjs.Container();
        _oHealthContainer.x = _pStartPosHealth.x;
        _oHealthContainer.y = _pStartPosHealth.y;
        s_oStage.addChild(_oHealthContainer);

        oSprite = s_oSpriteLibrary.getSprite('energy_bar_fill');
        var oEnergyBarFill = createBitmap(oSprite);
        oEnergyBarFill.x= 50;
        oEnergyBarFill.y= 20;
        _oHealthContainer.addChild(oEnergyBarFill);
        
        oSprite = s_oSpriteLibrary.getSprite('energy_bar_bg');
        var oEnergyBarBg = createBitmap(oSprite);
        _oHealthContainer.addChild(oEnergyBarBg);

        _oMask = new createjs.Shape();
        _oMask.graphics.beginFill("rgba(255,0,0,0.01)").drawRect(0, 0, oSprite.width-50,oSprite.height);
        _oMask.x= 40;
        _oMask.y= 5;
        _oHealthContainer.addChild(_oMask);

        oEnergyBarFill.mask = _oMask;

        oSprite = s_oSpriteLibrary.getSprite('shield_icon');
        oShieldIcon = createBitmap(oSprite);
        oShieldIcon.x= 50;
        oShieldIcon.y= 35;
        oShieldIcon.visible = false;
        _oHealthContainer.addChild(oShieldIcon);

        // TOTAL COINS INDICATOR (SCORE)
        _pStartPosScore = {x: COIN_WIDTH/2 + 20, y: _pStartPosExit.y};
        _oScoreContainer = new createjs.Container();
        _oScoreContainer.x = _pStartPosScore.x;
        _oScoreContainer.y = _pStartPosScore.y;
        s_oStage.addChild(_oScoreContainer);
        
        var oData = {   
                images: [s_oSpriteLibrary.getSprite("coin")], 
                framerate: 30,
                // width, height & registration point of each sprite
                frames: {width: COIN_WIDTH, height: COIN_HEIGHT, regX: 0, regY: 0}, 
                animations: {idle:[0, 19, "idle"]}
            };
        var oSpriteSheet = new createjs.SpriteSheet(oData);
        
        _oScoreIcon = createSprite(oSpriteSheet, "idle", 0, 0, COIN_WIDTH, COIN_HEIGHT);
        _oScoreIcon.regX = COIN_WIDTH/2;
        _oScoreIcon.regY = COIN_HEIGHT/2;
        _oScoreContainer.addChild(_oScoreIcon);

        _fScaleX = 1;
        _fScaleY = 1;

        _oScoreTextBack = new createjs.Text("0", "30px " + PRIMARY_FONT, "#000000");
        _oScoreTextBack.textAlign = "left";
        _oScoreTextBack.textBaseline = "alphabetic";
	_oScoreTextBack.x = _oScoreIcon.x + COIN_WIDTH/2 + 11;
        _oScoreTextBack.y = 0;
        _oScoreTextBack.outline = 3;
        _oScoreTextBack.textBaseline = "middle";
	_oScoreContainer.addChild(_oScoreTextBack);

        _oScoreText = new createjs.Text("0", "30px " + PRIMARY_FONT, PRIMARY_FONT_COLOR);
        _oScoreText.textAlign = "left";
        _oScoreText.textBaseline = "alphabetic";
	_oScoreText.x = _oScoreIcon.x + COIN_WIDTH/2 + 10;
        _oScoreText.y = 1;
        _oScoreText.textBaseline = "middle";
	_oScoreContainer.addChild(_oScoreText);

        // BEST SCORE INDICATOR
        _pStartPosBestScore = {x: COIN_WIDTH/2 + 40, y: CANVAS_HEIGHT - 60};
        _oBestScoreContainer = new createjs.Container();
        _oBestScoreContainer.x = _pStartPosBestScore.x;
        _oBestScoreContainer.y = _pStartPosBestScore.y;
        s_oStage.addChild(_oBestScoreContainer);

        oSprite = s_oSpriteLibrary.getSprite('best_score');
        _oBestScoreIcon = createBitmap(oSprite);
        _oBestScoreIcon.regX = oSprite.width/2;
        _oBestScoreIcon.regY = oSprite.height/2;
        _oBestScoreContainer.addChild(_oBestScoreIcon);

        _oBestScoreTextBack = new createjs.Text(s_iBestScore, "30px " + PRIMARY_FONT, "#000000");
        _oBestScoreTextBack.textAlign = "left";
        _oBestScoreTextBack.textBaseline = "alphabetic";
	_oBestScoreTextBack.x = _oBestScoreIcon.x + oSprite.width/2 + 11;
        _oBestScoreTextBack.y = 15;
        _oBestScoreTextBack.outline = 3;
        _oBestScoreTextBack.textBaseline = "middle";
	_oBestScoreContainer.addChild(_oBestScoreTextBack);

        _oBestScoreText = new createjs.Text(s_iBestScore, "30px " + PRIMARY_FONT, PRIMARY_FONT_COLOR);
        _oBestScoreText.textAlign = "left";
        _oBestScoreText.textBaseline = "alphabetic";
	_oBestScoreText.x = _oBestScoreIcon.x + oSprite.width/2 + 10;
        _oBestScoreText.y = 16;
        _oBestScoreText.textBaseline = "middle";
	_oBestScoreContainer.addChild(_oBestScoreText);

        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            var oSprite = s_oSpriteLibrary.getSprite('audio_icon');
            
            _pStartPosAudio = {x: _pStartPosExit.x - oSpriteExit.width/2 - oSprite.width/4, y: _pStartPosExit.y};
            _oAudioToggle = new CToggle(_pStartPosAudio.x, _pStartPosAudio.y, oSprite, s_bAudioActive,s_oStage);
            _oAudioToggle.addEventListener(ON_MOUSE_UP, this._onAudioToggle, this);
            _pStartPosFullscreen = {x: _pStartPosAudio.x - oSprite.width/2, y:_pStartPosAudio.y};
        }else{
            _pStartPosFullscreen = {x: _pStartPosExit.x - oSpriteExit.width - 10, y: _pStartPosExit.y};
        }

        var doc = window.document;
        var docEl = doc.documentElement;
        _fRequestFullScreen = docEl.requestFullscreen || docEl.mozRequestFullScreen || docEl.webkitRequestFullScreen || docEl.msRequestFullscreen;
        _fCancelFullScreen = doc.exitFullscreen || doc.mozCancelFullScreen || doc.webkitExitFullscreen || doc.msExitFullscreen;
        
        if(ENABLE_FULLSCREEN === false){
            _fRequestFullScreen = false;
        }
        
        if (_fRequestFullScreen && inIframe() === false){
            oSprite = s_oSpriteLibrary.getSprite('but_fullscreen');

            _oButFullscreen = new CToggle(_pStartPosFullscreen.x,_pStartPosFullscreen.y,oSprite,s_bFullscreen,s_oStage);
            _oButFullscreen.addEventListener(ON_MOUSE_UP, this._onFullscreenRelease, this);
        }
        
        if (s_bMobile) {
            _oButRight = new CGfxButton(CANVAS_WIDTH / 2 + 300, CANVAS_HEIGHT / 2, s_oSpriteLibrary.getSprite("button_right"),s_oStage);
            _oButLeft = new CGfxButton(CANVAS_WIDTH / 2 - 300, CANVAS_HEIGHT / 2, s_oSpriteLibrary.getSprite("button_left"),s_oStage);
        };
        
        this.refreshButtonPos(s_iOffsetX, s_iOffsetY);
    };

    this.toggleShieldIcon = function(bState) {
        oShieldIcon.visible = bState;
    };
    
    this.getScoreIconX = function() {
        return _oScoreContainer.x;
    };
    
    this.getScoreIconY = function() {
        return _oScoreContainer.y;
    };
    
    this.refreshButtonPos = function (iNewX, iNewY) {
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oAudioToggle.setPosition(_pStartPosAudio.x - iNewX, _pStartPosAudio.y + iNewY);
        }
        if (_fRequestFullScreen && inIframe() === false){
            _oButFullscreen.setPosition(_pStartPosFullscreen.x - iNewX,_pStartPosFullscreen.y + iNewY);
        }
        
        _oButExit.setPosition(_pStartPosExit.x - iNewX, _pStartPosExit.y + iNewY);

        _oHealthContainer.x = _pStartPosHealth.x + iNewX;
        _oHealthContainer.y = _pStartPosHealth.y + iNewY;
        _oScoreContainer.x = _pStartPosScore.x + iNewX;
        _oScoreContainer.y = _pStartPosScore.y + iNewY;
        _oBestScoreContainer.x = _pStartPosBestScore.x + iNewX;
        _oBestScoreContainer.y = _pStartPosBestScore.y - iNewY;
    };

    this.refreshBar = function(iValue){
        createjs.Tween.get(_oMask, {override:true}).to({scaleX:iValue}, 162, createjs.Ease.linear);//.call(function(){_oParent._removeTween()});
    };
    
    this.refreshScore = function (iScore) {
       _oScoreText.text = iScore;
       _oScoreTextBack.text = iScore;
       
       _oBestScoreTextBack.text = s_iBestScore;
       _oBestScoreText.text = s_iBestScore;
    };
    
    this.scoreIconPulse = function() {
        _oTween = createjs.Tween.get(_oScoreIcon).to({scaleX: _fScaleX * 1.4, scaleY: _fScaleY * 1.4}, 300, createjs.Ease.quadOut).to({scaleX: _fScaleX, scaleY: _fScaleY}, 300, createjs.Ease.quadIn);
    };
    
    this.unload = function () {        
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oAudioToggle.unload();
            _oAudioToggle = null;
        }
        
        if (_fRequestFullScreen && inIframe() === false){
            _oButFullscreen.unload();
        }
        
        _oButExit.unload();        
        s_oInterface = null;
    };
    
    this.gameOver = function(iScore){
        new CEndPanel(iScore);
    };
    
    this.showWin = function(){
        new CWinPanel();
    };
    
    this._onExit = function () {
        s_oGame.pause();
        _oAreYouSurePanel = new CAreYouSurePanel(s_oStage);
    };

    this._onAudioToggle = function () {
        createjs.Sound.setMute(s_bAudioActive);
        s_bAudioActive = !s_bAudioActive;
    };

    this._onFullscreenRelease = function(){
        if(s_bFullscreen) { 
            _fCancelFullScreen.call(window.document);
            s_bFullscreen = false;
        }else{
            _fRequestFullScreen.call(window.document.documentElement);
            s_bFullscreen = true;
        }
        
        sizeHandler();
    };

    this._onRestart = function(){
        s_oGame.onRestart();  
    };

    s_oInterface = this;

    this._init();

    return this;
}

var s_oInterface = null;