function CMain(oData) {
    var _bUpdate;
    var _iCurResource = 0;
    var RESOURCE_TO_LOAD = 0;
    var _iState = STATE_LOADING;
    var _oData;
    var _oPreloader;
    var _oHelp;
    var _oMenu;
    var _oGame;
    
    this.initContainer = function () {
        s_oCanvas = document.getElementById("canvas");
        s_oStage = new createjs.Stage(s_oCanvas);
	s_oStage.preventSelection = false;
        createjs.Touch.enable(s_oStage);

        s_bMobile = jQuery.browser.mobile;              // This will check if we are on mobile 
        if (s_bMobile === false) {
            s_oStage.enableMouseOver(20);
            $('body').on('contextmenu', '#canvas', function (e) {
                return false;
            });
        }

        s_iPrevTime = new Date().getTime();

        createjs.Ticker.addEventListener("tick", this._update);
        createjs.Ticker.setFPS(FPS);

        if (navigator.userAgent.match(/Windows Phone/i)) {
            DISABLE_SOUND_MOBILE = true;
        }

        s_oSpriteLibrary = new CSpriteLibrary();

        //ADD PRELOADER
        _oPreloader = new CPreloader();
    };

    this.preloaderReady = function () {
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            this._initSounds();
        }

        this._loadImages();
        _bUpdate = true;
    };

    this.soundLoaded = function () {
        _iCurResource++;
        var iPerc = Math.floor(_iCurResource / RESOURCE_TO_LOAD * 100);
        _oPreloader.refreshLoader(iPerc);

        if (_iCurResource === RESOURCE_TO_LOAD) {
            this._onRemovePreloader();
        }
    };

    this._initSounds = function () {
        if (!createjs.Sound.initializeDefaultPlugins()) {
            return;
        }

        if (navigator.userAgent.indexOf("Opera") > 0 || navigator.userAgent.indexOf("OPR") > 0) {
            createjs.Sound.alternateExtensions = ["mp3"];
            createjs.Sound.addEventListener("fileload", createjs.proxy(this.soundLoaded, this));

            createjs.Sound.registerSound("./sounds/soundtrack.ogg", "soundtrack");
            createjs.Sound.registerSound("./sounds/press_button.ogg", "click");
            createjs.Sound.registerSound("./sounds/game_win.ogg", "game_win");
            createjs.Sound.registerSound("./sounds/game_over.ogg", "game_over");
            createjs.Sound.registerSound("./sounds/death.ogg", "death");
            createjs.Sound.registerSound("./sounds/money.ogg", "money");
            createjs.Sound.registerSound("./sounds/money_bounce.ogg", "money_bounce");
            createjs.Sound.registerSound("./sounds/power_up.ogg", "power_up");
            createjs.Sound.registerSound("./sounds/stone_explosion.ogg", "stone_explosion");
            createjs.Sound.registerSound("./sounds/stone_on_shield.ogg", "stone_on_shield");
            createjs.Sound.registerSound("./sounds/pain.ogg", "pain");
            createjs.Sound.registerSound("./sounds/punch.ogg", "punch");

        } else {
            createjs.Sound.alternateExtensions = ["ogg"];
            createjs.Sound.addEventListener("fileload", createjs.proxy(this.soundLoaded, this));

            createjs.Sound.registerSound("./sounds/soundtrack.mp3", "soundtrack");
            createjs.Sound.registerSound("./sounds/press_button.mp3", "click");
            createjs.Sound.registerSound("./sounds/game_win.mp3", "game_win");
            createjs.Sound.registerSound("./sounds/game_over.mp3", "game_over");
            createjs.Sound.registerSound("./sounds/death.mp3", "death");
            createjs.Sound.registerSound("./sounds/money.mp3", "money");
            createjs.Sound.registerSound("./sounds/money_bounce.mp3", "money_bounce");
            createjs.Sound.registerSound("./sounds/power_up.mp3", "power_up");
            createjs.Sound.registerSound("./sounds/stone_explosion.mp3", "stone_explosion");
            createjs.Sound.registerSound("./sounds/stone_on_shield.mp3", "stone_on_shield");
            createjs.Sound.registerSound("./sounds/pain.mp3", "pain");
            createjs.Sound.registerSound("./sounds/punch.mp3", "punch");
        }

        RESOURCE_TO_LOAD += 12;
    };

    this._loadImages = function () {
        s_oSpriteLibrary.init(this._onImagesLoaded, this._onAllImagesLoaded, this);

        for (var i = 1; i < 10; i++) {
            s_oSpriteLibrary.addSprite("cyclops_000"+i, "./sprites/cyclops/cyclops_animations_000" + i + ".png");
        };
        
        for (var i = 10; i < 35; i++) {
            s_oSpriteLibrary.addSprite("cyclops_00"+i, "./sprites/cyclops/cyclops_animations_00" + i + ".png");
        };
        
        for (var i = 0; i < 9; i++) {
            s_oSpriteLibrary.addSprite("logo_menu_"+i, "./sprites/logo_explosion/logo_" + i + ".png");
        };

        s_oSpriteLibrary.addSprite("but_exit", "./sprites/but_exit.png");
        s_oSpriteLibrary.addSprite("audio_icon", "./sprites/audio_icon.png");
        s_oSpriteLibrary.addSprite("but_play", "./sprites/but_play.png");
        s_oSpriteLibrary.addSprite("but_restart", "./sprites/but_restart.png");
        s_oSpriteLibrary.addSprite("but_home", "./sprites/but_home.png");
        s_oSpriteLibrary.addSprite("msg_box", "./sprites/msg_box.png");
        s_oSpriteLibrary.addSprite("credits_bg", "./sprites/credits_bg.png");
        s_oSpriteLibrary.addSprite("but_credits", "./sprites/but_credits.png");
        s_oSpriteLibrary.addSprite("logo_ctl", "./sprites/logo_ctl.png");
        s_oSpriteLibrary.addSprite("but_fullscreen", "./sprites/but_fullscreen.png");
        s_oSpriteLibrary.addSprite("bg_end_panel", "./sprites/bg_end_panel.png");
        s_oSpriteLibrary.addSprite("bg_game", "./sprites/bg_game.jpg");
        s_oSpriteLibrary.addSprite("but_no", "./sprites/but_no.png");
        s_oSpriteLibrary.addSprite("but_yes", "./sprites/but_yes.png");
        s_oSpriteLibrary.addSprite("button_right","./sprites/button_right.png");
        s_oSpriteLibrary.addSprite("button_left","./sprites/button_left.png");
        s_oSpriteLibrary.addSprite("stone","./sprites/stone.png");
        s_oSpriteLibrary.addSprite("powerup_0","./sprites/powerup_0.png");
        s_oSpriteLibrary.addSprite("powerup_1","./sprites/powerup_1.png");
        s_oSpriteLibrary.addSprite("coin","./sprites/coin.png");
        s_oSpriteLibrary.addSprite("best_score","./sprites/best_score.png");
        s_oSpriteLibrary.addSprite("cloud","./sprites/cloud.png");
        s_oSpriteLibrary.addSprite("debris","./sprites/debris.png");
        s_oSpriteLibrary.addSprite("floor","./sprites/floor.png");
        s_oSpriteLibrary.addSprite("mountain","./sprites/mountain.png");
        s_oSpriteLibrary.addSprite("debris","./sprites/debris.png");
        s_oSpriteLibrary.addSprite("player","./sprites/hercules.png");
        s_oSpriteLibrary.addSprite("energy_bar_bg","./sprites/energy_bar_bg.png");
        s_oSpriteLibrary.addSprite("energy_bar_fill","./sprites/energy_bar_fill.png");
        s_oSpriteLibrary.addSprite("shield_icon","./sprites/shield_icon.png");
        s_oSpriteLibrary.addSprite("keyboard","./sprites/keyboard.png");
        s_oSpriteLibrary.addSprite("help_smartphone","./sprites/help_smartphone.png");
        s_oSpriteLibrary.addSprite("help_touch","./sprites/help_touch.png");
        s_oSpriteLibrary.addSprite("smartphone_rotation","./sprites/smartphone_rotation.png");

        RESOURCE_TO_LOAD += s_oSpriteLibrary.getNumSprites();
        s_oSpriteLibrary.loadSprites();
    };

    this._onImagesLoaded = function () {
        _iCurResource++;
        var iPerc = Math.floor(_iCurResource / RESOURCE_TO_LOAD * 100);
        _oPreloader.refreshLoader(iPerc);
        
        if (_iCurResource === RESOURCE_TO_LOAD) {
            this._onRemovePreloader();
        }
    };

    this._onAllImagesLoaded = function () {
        
    };

    this.onAllPreloaderImagesLoaded = function () {
        this._loadImages();
    };
    
    this._onRemovePreloader = function(){
        try{
            saveItem("ls_available","ok");
        }catch(evt){
            // localStorage not defined
            s_bStorageAvailable = false;
        }

        _oPreloader.unload();

        if (!isIOS()) {
            if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
                s_oSoundTrack = createjs.Sound.play("soundtrack", {loop: -1});
            }
        }

        this.gotoMenu();
    };
    
    this.gotoMenu = function () {
        _oMenu = new CMenu();
        _iState = STATE_MENU;
    };

    this.gotoGame = function () {
        _oGame = new CGame(_oData);
        _iState = STATE_GAME;

        $(s_oMain).trigger("start_session");
    };

    this.gotoHelp = function(){
        _oHelp = new CHelp();
        _iState = STATE_HELP;
    };
    
    this.stopUpdate = function(){
        _bUpdate = false;
        createjs.Ticker.paused = true;
        $("#block_game").css("display","block");
	createjs.Sound.setMute(true);
    };

    this.startUpdate = function(){
        s_iPrevTime = new Date().getTime();
        _bUpdate = true;
        createjs.Ticker.paused = false;
        $("#block_game").css("display","none");
        
        if(s_bAudioActive){
            createjs.Sound.setMute(false);
        }
    };

    this._update = function (event) {
        if (_bUpdate === false) {
            return;
        }
        var iCurTime = new Date().getTime();
        s_iTimeElaps = iCurTime - s_iPrevTime;
        s_iCntTime += s_iTimeElaps;
        s_iCntFps++;
        s_iPrevTime = iCurTime;

        if (s_iCntTime >= 1000) {
            s_iCurFps = s_iCntFps;
            s_iCntTime -= 1000;
            s_iCntFps = 0;
        }
        
        if (_iState === STATE_GAME) {
            _oGame.update();
        }
        s_oStage.update(event);
    };

    s_oMain = this;

    _oData = oData;
    ENABLE_FULLSCREEN = oData.fullscreen;
    ENABLE_CHECK_ORIENTATION = oData.check_orientation;
    
    this.initContainer();
}

var s_bMobile;
var s_bAudioActive = true;
var s_bFullscreen = false;
var s_iCntTime = 0;
var s_iTimeElaps = 0;
var s_iPrevTime = 0;
var s_iCntFps = 0;
var s_iCurFps = 0;

var s_iLevelReached = 1;

var s_szCurDraw;
var s_oDrawLayer;
var s_oStage;
var s_oMain;
var s_oSpriteLibrary;
var s_oSoundTrack = null;
var s_oCanvas;
var s_iBestScore = 0;

var s_bStorageAvailable = true;
var s_bCanOrientate = false;