 function CMenu() {
    var _oBackgroundContainer;
    var _oBg;
    var _oMountain;
    var _oCyclops;
    var _oShake;
    var _iAnimationPause = 500; // How many ms the frame will freeze at the end of each punch
    var _oFloor;
    var _oGameLogo;
    var _oButPlay;
    var _oFade;
    var _oAudioToggle;
    var _oButCredits;
    var _oCreditsPanel = null;
    var _oButFullscreen;
    var _fRequestFullScreen = null;
    var _fCancelFullScreen = null;
    var _pStartPosAudio;
    var _pStartPosCredits;
    var _pStartPosFullscreen;
    
    this._init = function () {
        _oBackgroundContainer = new createjs.Container();
        s_oStage.addChild(_oBackgroundContainer);
        
        // CREATE THE BACKGROUND SKY
        _oBg = createBitmap(s_oSpriteLibrary.getSprite('bg_game'));
        _oBg.regX = 800/2;
        _oBg.regY = 1450/2;
        _oBg.x = CANVAS_WIDTH / 2;
        _oBg.y = CANVAS_HEIGHT / 2;
        _oBackgroundContainer.addChild(_oBg);

        // CREATE THE BACKGROUND MOUNTAINS
        _oMountain = createBitmap(s_oSpriteLibrary.getSprite("mountain"));
        _oMountain.regX = 437/2;
        _oMountain.regY = 953/2;
        _oMountain.x = CANVAS_WIDTH / 2;
        _oMountain.y = CANVAS_HEIGHT / 2 + 100;
        _oBackgroundContainer.addChild(_oMountain);
        
        // CREATE THE CYCLOPS
        var data = {    
            images: [s_oSpriteLibrary.getSprite("cyclops_0001"),
                     s_oSpriteLibrary.getSprite("cyclops_0002"),
                     s_oSpriteLibrary.getSprite("cyclops_0003"),
                     s_oSpriteLibrary.getSprite("cyclops_0004"),
                     s_oSpriteLibrary.getSprite("cyclops_0005"),
                     s_oSpriteLibrary.getSprite("cyclops_0006"),
                     s_oSpriteLibrary.getSprite("cyclops_0007"),
                     s_oSpriteLibrary.getSprite("cyclops_0008"),
                     s_oSpriteLibrary.getSprite("cyclops_0009"),
                     s_oSpriteLibrary.getSprite("cyclops_0010"),
                     s_oSpriteLibrary.getSprite("cyclops_0011"),
                     s_oSpriteLibrary.getSprite("cyclops_0012"),
                     s_oSpriteLibrary.getSprite("cyclops_0013"),
                     s_oSpriteLibrary.getSprite("cyclops_0014"),
                     s_oSpriteLibrary.getSprite("cyclops_0015"),
                     s_oSpriteLibrary.getSprite("cyclops_0016"),
                     s_oSpriteLibrary.getSprite("cyclops_0017"),
                     s_oSpriteLibrary.getSprite("cyclops_0018"),
                     s_oSpriteLibrary.getSprite("cyclops_0019"),
                     s_oSpriteLibrary.getSprite("cyclops_0020"),
                     s_oSpriteLibrary.getSprite("cyclops_0021"),
                     s_oSpriteLibrary.getSprite("cyclops_0022"),
                     s_oSpriteLibrary.getSprite("cyclops_0023"),
                     s_oSpriteLibrary.getSprite("cyclops_0024"),
                     s_oSpriteLibrary.getSprite("cyclops_0025"),
                     s_oSpriteLibrary.getSprite("cyclops_0026"),
                     s_oSpriteLibrary.getSprite("cyclops_0027"),
                     s_oSpriteLibrary.getSprite("cyclops_0028"),
                     s_oSpriteLibrary.getSprite("cyclops_0029"),
                     s_oSpriteLibrary.getSprite("cyclops_0030"),
                     s_oSpriteLibrary.getSprite("cyclops_0031"),
                     s_oSpriteLibrary.getSprite("cyclops_0032"),
                     s_oSpriteLibrary.getSprite("cyclops_0033"),
                     s_oSpriteLibrary.getSprite("cyclops_0034")],
            frames: {width: 716, height: 719},
            animations: { idle:         [0, 17], 
                          punch_right:  [18, 23], 
                          punch_left:   [24, 29], 
                          back_to_idle: [30, 33, "idle"]
                        },
            framerate: 15
        };
        var oSpriteSheetCyclops = new createjs.SpriteSheet(data);

        _oCyclops = createSprite(oSpriteSheetCyclops, "idle", 0, 0, 716, 719);
        _oCyclops.regX = 716/2;
        _oCyclops.regY = 719/2;
        _oCyclops.scaleX = _oCyclops.scaleY = 0.7;
        _oCyclops.x = CANVAS_WIDTH / 2 + 60;
        _oCyclops.y = CANVAS_HEIGHT / 2 - 50;
        _oBackgroundContainer.addChild(_oCyclops);
        _oCyclops.on('animationend', this._changeCyclopsAnimation );
        
        // CREATE THE BACKGROUND FLOOR
        _oFloor = createBitmap(s_oSpriteLibrary.getSprite("floor"));
        _oFloor.regX = 800/2;
        _oFloor.regY = 651/2;
        _oFloor.x = CANVAS_WIDTH / 2;
        _oFloor.y = CANVAS_HEIGHT / 2 + 300;
        _oBackgroundContainer.addChild(_oFloor);

        window.addEventListener('deviceorientation', function(eventData) {
            if(eventData.gamma !== null){
                s_bCanOrientate = true;
            }
        }, false);

        // CREATE THE GAME LOGO
        var data = {    
            images: [s_oSpriteLibrary.getSprite("logo_menu_0"),
                     s_oSpriteLibrary.getSprite("logo_menu_1"),
                     s_oSpriteLibrary.getSprite("logo_menu_2"),
                     s_oSpriteLibrary.getSprite("logo_menu_3"),
                     s_oSpriteLibrary.getSprite("logo_menu_4"),
                     s_oSpriteLibrary.getSprite("logo_menu_5"),
                     s_oSpriteLibrary.getSprite("logo_menu_6"),
                     s_oSpriteLibrary.getSprite("logo_menu_7"),
                     s_oSpriteLibrary.getSprite("logo_menu_8")],
            frames: {width: 720, height: 770},
            animations: { idle: [0, 0], explode: [1, 8, false]},
            framerate: 30 };
        var oSpriteSheetLogo = new createjs.SpriteSheet(data);

        _oGameLogo = createSprite(oSpriteSheetLogo, "idle", 720, 770, 720/2, 770/2);
        _oGameLogo.regX = 720/2;
        _oGameLogo.regY = 770/2;
        _oGameLogo.x = CANVAS_WIDTH / 2;
        _oGameLogo.y = -150;
        createjs.Tween.get(_oGameLogo, {loop: false}).to({y: CANVAS_HEIGHT / 2 + 150}, 800, createjs.Ease.cubicIn).call(this._handleComplete);
        _oBackgroundContainer.addChild(_oGameLogo);

        // CREATE THE INTERFACE BUTTONS
        var oSpritePlay = s_oSpriteLibrary.getSprite('but_play');
        _oButPlay = new CButtonPlay((CANVAS_WIDTH / 2), -1000, oSpritePlay);
        _oButPlay.addEventListener(ON_MOUSE_UP, this._onButPlayRelease, this);
        createjs.Tween.get(_oButPlay.getSprite(), {loop: false}).to({y: CANVAS_HEIGHT / 2 + 400}, 1500, createjs.Ease.quintIn).call(_oButPlay._onTweenEnd);

        var oSprite = s_oSpriteLibrary.getSprite('but_credits');
        _pStartPosCredits = {x:20 + oSprite.width/2,y:(oSprite.height / 2) + 10};
        _oButCredits = new CGfxButton(_pStartPosCredits.x, _pStartPosCredits.y, oSprite);
        _oButCredits.addEventListener(ON_MOUSE_UP, this._onCredits, this);

        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            var oSprite = s_oSpriteLibrary.getSprite('audio_icon');
            _pStartPosAudio = {x: CANVAS_WIDTH - oSprite.width/4 -20, y: (oSprite.height / 2) + 10};
            _oAudioToggle = new CToggle(_pStartPosAudio.x, _pStartPosAudio.y, oSprite, s_bAudioActive, s_oStage);
            _oAudioToggle.addEventListener(ON_MOUSE_UP, this._onAudioToggle, this);
        }
        
        var doc = window.document;
        var docEl = doc.documentElement;
        _fRequestFullScreen = docEl.requestFullscreen || docEl.mozRequestFullScreen || docEl.webkitRequestFullScreen || docEl.msRequestFullscreen;
        _fCancelFullScreen = doc.exitFullscreen || doc.mozCancelFullScreen || doc.webkitExitFullscreen || doc.msExitFullscreen;
        
        if(ENABLE_FULLSCREEN === false){
            _fRequestFullScreen = false;
        }
        
        if (_fRequestFullScreen && inIframe() === false){
            oSprite = s_oSpriteLibrary.getSprite('but_fullscreen');
            _pStartPosFullscreen = {x:_pStartPosCredits.x + oSprite.width/2 + 10,y:_pStartPosCredits.y};

            _oButFullscreen = new CToggle(_pStartPosFullscreen.x,_pStartPosFullscreen.y,oSprite,s_bFullscreen,s_oStage);
            _oButFullscreen.addEventListener(ON_MOUSE_UP, this._onFullscreenRelease, this);
        }
        
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);

        s_oStage.addChild(_oFade);

        createjs.Tween.get(_oFade).to({alpha: 0}, 500).call(function () {
            s_oStage.removeChild(_oFade);
        });
        
        if(!s_bStorageAvailable){
            new CMsgBox(TEXT_ERR_LS,s_oStage);
        }else{
            var aBestScore = getItem("cyclopsruins_best_score");
            if(aBestScore !== null ){
                s_iBestScore = aBestScore;
            }
        }
        
        this.refreshButtonPos(s_iOffsetX, s_iOffsetY);
        
        if (!isIOS()) {
            setVolume(s_oSoundTrack, 0.4);
        };
    };

    this._handleComplete = function() {
        playSound("stone_explosion",1,0);
        _oGameLogo.gotoAndPlay('explode');
    };

    this._changeCyclopsAnimation = function() {
        if (_oCyclops.currentAnimation === 'idle') {
                _oCyclops.gotoAndPlay('punch_right');
        } else if (_oCyclops.currentAnimation === 'punch_right') {
            _oCyclops.gotoAndStop(23);
            playSound("punch",1,0);
            _oShake = new CShake(_oBackgroundContainer, 500, 5, 20);
            setTimeout(function(){ 
                _oCyclops.gotoAndPlay('punch_left');
            }, _iAnimationPause);
        } else if (_oCyclops.currentAnimation === 'punch_left') {
            _oCyclops.gotoAndStop(29);
            playSound("punch",1,0);
            _oShake = new CShake(_oBackgroundContainer, 500, 5, 20);
            setTimeout(function(){ 
                _oCyclops.gotoAndPlay('back_to_idle');
            }, _iAnimationPause);
        };
    };

    this.pause = function() {
        _oCyclops.stop();
    };
    
    this.unpause = function() {
        _oCyclops.play();
    };

    this.unload = function () {
        _oButPlay.unload();
        _oButPlay = null;

        _oButCredits.unload();
        
        s_oStage.removeAllChildren();

        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oAudioToggle.unload();
            _oAudioToggle = null;
        }
        if (_fRequestFullScreen && inIframe() === false){
            _oButFullscreen.unload();
        }
        s_oMenu = null;
    };

    this.refreshButtonPos = function (iNewX, iNewY) {
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oAudioToggle.setPosition(_pStartPosAudio.x - iNewX, _pStartPosAudio.y + iNewY);
        }
        if (_fRequestFullScreen && inIframe() === false){
            _oButFullscreen.setPosition(_pStartPosFullscreen.x + iNewX,_pStartPosFullscreen.y + iNewY);
        }

        _oButCredits.setPosition(_pStartPosCredits.x + iNewX,_pStartPosCredits.y + iNewY);
    };
    
    this.exitFromCredits = function(){
        s_oMenu.unpause();
        _oCreditsPanel = null;
    };

    this._onAudioToggle = function () {
        createjs.Sound.setMute(s_bAudioActive);
        s_bAudioActive = !s_bAudioActive;
    };
    
    this._onCredits = function(){
        _oCreditsPanel = new CCreditsPanel();
    };

    this._onButPlayRelease = function () {
        this.unload();

        if (isIOS() && s_oSoundTrack === null) {
            if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
                s_oSoundTrack = createjs.Sound.play("soundtrack", {loop: -1});
            }
        }else{
             playSound("click", 1, 0);
        }
        
        s_oMain.gotoGame();
    };
    
    this._onFullscreenRelease = function(){
        if(s_bFullscreen) { 
            _fCancelFullScreen.call(window.document);
            s_bFullscreen = false;
        }else{
            _fRequestFullScreen.call(window.document.documentElement);
            s_bFullscreen = true;
        }
        
        sizeHandler();
    };
    
    s_oMenu = this;

    this._init();
}

var s_oMenu = null;