function CPowerUp (iType, oParentContainer) {
    var _oPowerUp;
    var _iType = iType;
    var _iWidth = [212, 170];
    var _iHeight = [119, 109];
    var _iFallingTime = 7000;
    var _iFloorLimit = s_oPlayer.getY() + 50;
    var bColliding;
    
    var _bUpdate;
    var _iCntTime;
    var _iMaxTime;
    var _iCurStartY;
    var _iCurYIndex;

    this._init = function(oParentContainer) {
        var _iXRandom = Math.floor((Math.random() * (CANVAS_WIDTH-200)) + 150);
        bColliding = false;
        _iCurYIndex = 0;

        var oData = {   
                images: [s_oSpriteLibrary.getSprite("powerup_" + _iType)], 
                framerate: 30,
                // width, height & registration point of each sprite
                frames: {width: _iWidth[_iType], height: _iHeight[_iType], regX: _iWidth[_iType]/2, regY: _iHeight[_iType]/2 + 50},
                animations: {idle:[0, 24, "idle"]}
        };
        var oSpriteSheet = new createjs.SpriteSheet(oData);

        _oPowerUp = createSprite(oSpriteSheet, "idle", _iWidth[_iType]/2, _iHeight[_iType]/2, _iWidth[_iType], _iHeight[_iType]);
        _oPowerUp.x = _iXRandom;
        _oPowerUp.y = -100;
        oParentContainer.addChild(_oPowerUp);
        
        _iCurStartY = _oPowerUp.y;
        _iCntTime = 0;
        _iMaxTime = _iFallingTime;
        _bUpdate = true;
    };
    
    this.isStone = function() {
        return false;
    };

    this.returnColliding = function() {
        return bColliding;
    };

    this.isShield = function() {
        if (_iType === POWER_UP_SHIELD) { 
            return true; 
        } else { 
            return false;
        };
    };

    this._BounceBack = function() {
        createjs.Tween.get(_oPowerUp, {loop: false}).to({y: _iFloorLimit - 50}, 1000, createjs.Ease.bounceOut).call(this.destroyPowerUp);
    }


    this.destroyPowerUp = function() {
        createjs.Tween.get(_oPowerUp).to({alpha: 0}, 1000).call(function () {
            oParentContainer.removeChild(_oPowerUp);
        });
        
        bColliding = true;
    };
    
    this.getX = function(){
        return _oPowerUp.x;
    };

    this.getY = function(){
        return _oPowerUp.y;
    };

    // update the Y position in a "tween" way
    this.update = function(){
        if(!_bUpdate) {
            return; };
        
        _iCntTime+= s_iTimeElaps;
        
        if ( _iCntTime >= _iMaxTime ){
            _bUpdate = false;
            this._BounceBack();
        }else{
            var fLerpY = s_oTweenController.easeInCubic( _iCntTime, 0 ,1, _iMaxTime);
            var iValue = s_oTweenController.tweenValue( _iCurStartY, _iFloorLimit - 300, fLerpY);
            _oPowerUp.y = iValue;
        }
    };

    var s_oPowerUp = this;

    this._init(oParentContainer);
};