function CStone (oParentContainer, oPlayer) {
    var _oStone;
    var _oShake;
    var _oCoin;
    var _iStoneFallingTime = 3; // Seconds
    var _oPlayer = oPlayer;
    var _iFloorLimit = s_oPlayer.getY();
    var bColliding;
    
    var _bUpdate;
    var _iCntTime;
    var _iMaxTime;
    var _iCurStartY;
    var _iCurYIndex;

    this._init = function(oParentContainer) {
        var _iXRandom = Math.floor((Math.random() * (CANVAS_WIDTH-200)) + 150);
        bColliding = false;
        _iCurYIndex = 0;

        var oData = {   
                images: [s_oSpriteLibrary.getSprite("stone")], 
                framerate: 15,
                // width, height & registration point of each sprite
                frames: {width: 200, height: 200, regX: 100, regY: 150}, 
                animations: {idle:[0, 0], explosion:[1, 5, 5]}
            };
        var oSpriteSheet = new createjs.SpriteSheet(oData);

        _oStone = createSprite(oSpriteSheet, "idle", 100, 150, 200, 200);
        _oStone.scaleX = _oStone.scaleY = Math.floor((Math.random() * 0.1) + 1);
        _oStone.x = _iXRandom;
        _oStone.y = -100;
        _oStone.on('animationend', this.destroyStone );
        oParentContainer.addChild(_oStone);
        
        _iCurStartY = _oStone.y;
        _iCntTime = 0;
        _iMaxTime = _iStoneFallingTime * 1000;
        _bUpdate = true;
    };

    this.returnColliding = function() {
        return bColliding;
    };
    
    this.isStone = function() {
        return true;
    };

    this.stopTween = function() {        
        if (_oStone.currentAnimation === "idle") {
            playSound("stone_explosion",1,0);
            
            s_oGame.stoneBroken(_oStone.x, _iFloorLimit - (COIN_HEIGHT/2) );
            _oStone.gotoAndPlay('explosion');
        };
        
        bColliding = true;
    };
    
    this.destroyStone = function() {
        if (_oStone.currentAnimation === "explosion") {
            oParentContainer.removeChild(_oStone);
        };
    };

    this.getX = function(){
        return _oStone.x;
    };

    this.getY = function(){
        return _oStone.y;
    };
    
    // update the Y position in a "tween" way
    this.update = function(){
        if(!_bUpdate) {
            return; };
        
        _iCntTime+= s_iTimeElaps;
        
        if ( _iCntTime >= _iMaxTime ){
            _bUpdate = false;
            this.stopTween();
        }else{
            var fLerpY = s_oTweenController.easeInCubic( _iCntTime, 0 ,1, _iMaxTime);
            var iValue = s_oTweenController.tweenValue( _iCurStartY, _iFloorLimit, fLerpY);
            _oStone.y = iValue;
        }
    };

    var s_oStone = this;

    this._init(oParentContainer);
};